package org.jeecg.modules.stm.project.report.controller;

import java.util.Arrays;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.project.report.entity.StProjectReport;
import org.jeecg.modules.stm.project.report.service.IStProjectReportService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;


import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 项目实施报告
 * @Author: jeecg-boot
 * @Date:   2023-08-17
 * @Version: V1.0
 */
  
@RestController
@RequestMapping("/project.report/stProjectReport")
@Slf4j
public class StProjectReportController extends JeecgController<StProjectReport, IStProjectReportService> {
	@Autowired
	private IStProjectReportService stProjectReportService;
	
	/**
	 * 分页列表查询
	 *
	 * @param stProjectReport
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "项目实施报告-分页列表查询")
	  
	@GetMapping(value = "/list")
	public Result<IPage<StProjectReport>> queryPageList(StProjectReport stProjectReport,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<StProjectReport> queryWrapper = QueryGenerator.initQueryWrapper(stProjectReport, req.getParameterMap());
		Page<StProjectReport> page = new Page<StProjectReport>(pageNo, pageSize);
		IPage<StProjectReport> pageList = stProjectReportService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param stProjectReport
	 * @return
	 */
	@AutoLog(value = "项目实施报告-添加")
	  
	@RequiresPermissions("project.report:st_project_report:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody StProjectReport stProjectReport) {
		stProjectReportService.save(stProjectReport);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param stProjectReport
	 * @return
	 */
	@AutoLog(value = "项目实施报告-编辑")
	  
	@RequiresPermissions("project.report:st_project_report:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody StProjectReport stProjectReport) {
		stProjectReportService.updateById(stProjectReport);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "项目实施报告-通过id删除")
	  
	@RequiresPermissions("project.report:st_project_report:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		stProjectReportService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "项目实施报告-批量删除")
	  
	@RequiresPermissions("project.report:st_project_report:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.stProjectReportService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "项目实施报告-通过id查询")
	  
	@GetMapping(value = "/queryById")
	public Result<StProjectReport> queryById(@RequestParam(name="id",required=true) String id) {
		StProjectReport stProjectReport = stProjectReportService.getById(id);
		if(stProjectReport==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(stProjectReport);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param stProjectReport
    */
    @RequiresPermissions("project.report:st_project_report:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, StProjectReport stProjectReport) {
        return super.exportXls(request, stProjectReport, StProjectReport.class, "项目实施报告");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("project.report:st_project_report:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, StProjectReport.class);
    }

}
